local jkPumpkinFarm = ...

jkPumpkinFarm:registerAssetProcessor("models/pumpkin.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

jkPumpkinFarm:registerAssetId("models/pumpkin.fbx/Materials/transparent_roof", MOD_NS .. "TRANSPARENT_FARM_ROOF")
jkPumpkinFarm:override({
    Id = MOD_NS .. "TRANSPARENT_FARM_ROOF",
	HasAlphaTest = true,
	HasShadow = true,
	BackFaceVisible = true
})

jkPumpkinFarm:registerAssetId("models/pumpkin.fbx/Prefab/ResourcePumpkin", MOD_NS .. "PREFAB_RESOURCE_PUMPKIN")
jkPumpkinFarm:registerAssetId("models/pumpkin.fbx/Prefab/PumpkinFarmPart", MOD_NS .. "PREFAB_PUMPKIN_FARM")
jkPumpkinFarm:registerAssetId("models/pumpkin.fbx/Prefab/ConstructionSteps/PumpkinFarm_Construction", MOD_NS .. "PREFAB_PUMPKIN_FARM_CONSTRUCTION")


jkPumpkinFarm:registerPrefabComponent("models/pumpkin.fbx/Prefab/PumpkinFarmPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = { 5, 7}
})

jkPumpkinFarm:registerPrefabComponent("models/pumpkin.fbx/Prefab/PumpkinFarmPart/Door", {
	DataType = "COMP_GROUNDED",
	AutoDisable = true
})

jkPumpkinFarm:register({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "PUMPKIN_FARM_PART",
	Description = "",
	ConstructionVisual = MOD_NS .. "PREFAB_PUMPKIN_FARM_CONSTRUCTION",
	AssetBuildingFunction = MOD_NS .. "BUILDING_FUNCTION_PUMPKIN_FARM",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {5, 7}, {-0.5, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
			}
		}
	},
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_PUMPKIN_FARM"
	},
	Cost = {
		BuildRightTaxes = {
			{ Resource = "GOLD_COINS", Quantity = 100 }
		},
		UpkeepCost = {
			{ Resource = "GOLD_COINS", Quantity = 15 }
		},
		ResourceNeededList = {
			{
				{ Resource = "WOOD", Quantity = 25 },
			},
			{
				{ Resource = "STONE", Quantity = 10 },
				{ Resource = "PLANK", Quantity = 10 }
			}
		}
	}
})
