local jkPumpkinFarm = ...

jkPumpkinFarm:registerAssetId("models/pumpkin.fbx/Prefab/TypeA", MOD_NS .. "PREFAB_PUMPKIN_TYPE_A")
jkPumpkinFarm:registerAssetId("models/pumpkin.fbx/Prefab/TypeB", MOD_NS .. "PREFAB_PUMPKIN_TYPE_B")
jkPumpkinFarm:registerAssetId("models/pumpkin.fbx/Prefab/TypeC", MOD_NS .. "PREFAB_PUMPKIN_TYPE_C")

jkPumpkinFarm:registerAssetId("models/pumpkin.fbx/Materials/dried_leaves", MOD_NS .. "DRIED_FIELD_MATERIAL")
jkPumpkinFarm:overrideAsset({
    Id = MOD_NS .. "DRIED_FIELD_MATERIAL",
    HasAlphaTest = true,
    HasShadow = true,
    RenderMode = MATERIAL_RENDER_MODE.DEFAULT,
})

jkPumpkinFarm:registerAssetId("icons/pumpkin.png", MOD_NS .. "ICON_PUMPKIN", "ATLAS_CELL")
jkPumpkinFarm:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_PUMPKINS",
	ResourceName = "RESOURCE_PUMPKINS_NAME",
	Icon = MOD_NS .. "ICON_PUMPKIN",
	ResourceTypeList = { "FOOD", "GRANARY", "RESOURCE_FOOD" },
    VillagerBuyingPrice = { Resource = "GOLD_COINS", Quantity = 8 },
	IsTradable = true,
	ResourceLayoutType = "BAGS",
	DisplayInInventory = true,
    DisplayInToolbar = true,
})


jkPumpkinFarm:registerAssetId("models/pumpkin.fbx/Materials/pumpkin_material", MOD_NS .. "TRANSPARENT_PUMPKIN")
jkPumpkinFarm:overrideAsset({
    Id = MOD_NS .. "TRANSPARENT_PUMPKIN",
    HasAlphaTest = true,
    BackFaceVisible = true,
    HasShadow = true,
    RenderMode = MATERIAL_RENDER_MODE.DEFAULT,
})


local PumpkinPartPath = "models/pumpkin.fbx/Prefab/PumpkinPart"
jkPumpkinFarm:registerAssetId(PumpkinPartPath, MOD_NS .. "PUMPKIN_PREFAB")

jkPumpkinFarm:registerPrefabComponent(PumpkinPartPath, {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_PUMPKINS",
    IsReplenishable = false,
    ResourceValue = 3,
    AvailableQuantity = 3,
    Radius = 1.3,
    IsDestroyWhenEmpty = true,
    HasMaximumWorkstation = false
})
jkPumpkinFarm:registerPrefabComponent(PumpkinPartPath, {
    DataType = MOD_NS .. "PUMPKIN_RANDOMIZER_COMPONENT",
})

jkPumpkinFarm:registerPrefabComponent(PumpkinPartPath, { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 10.0 })
jkPumpkinFarm:registerPrefabComponent(PumpkinPartPath, { DataType = "COMP_CROP_FIELD_ELEMENT" })

jkPumpkinFarm:registerAsset({
    DataType = "PLANTABLE",
    Id = MOD_NS .. "PLANTABLE_PUMPKIN",
    Name = MOD_NS .. "PLANTABLE_PUMPKIN_NAME",
    Icon = MOD_NS .. "ICON_PUMPKIN",
    PlantPrefab = MOD_NS .. "PUMPKIN_PREFAB",
    MinimumScale = 0.9,
    MaximumScale = 1.5
})


-- Zone -------------------------------------------------------------------------------------
jkPumpkinFarm:registerAsset({
    DataType = "ZONE",
    Id = MOD_NS .. "ZONE_PUMPKIN_FARM",
    Icon = MOD_NS .. "ICON_PUMPKIN",
    HoverIcon = MOD_NS .. "ICON_PUMPKIN",
    SelectionIcon = MOD_NS .. "ICON_PUMPKIN",
    Name = MOD_NS .. "ZONE_PUMPKIN_FARM_NAME",
    Description = MOD_NS .. "ZONE_PUMPKIN_FARM_DESC",
    Color = {4.5, 1.50, 1.20, 0.9},
    DesirabilityLayerToShow = "DESIRABILITY_FERTILITY"
})

-- Farm Field Config -------------------------------------------------------------------------------------
jkPumpkinFarm:registerAsset({
    DataType = "FARM_FIELD_CONFIG",
    Id = MOD_NS .."FARM_FIELD_CONFIG_PUMPKIN_FARM",
    ZoneType = MOD_NS .."ZONE_PUMPKIN_FARM",
    PlantPrefab = MOD_NS .."PUMPKIN_PREFAB",
    HasPlantingCycle = true,
    IsScaling = true,
    StartScaleValue = 0.05,
    RowDistance = 4,
    ItemDistance = 4,
    RandomOrientation = {-90, 90},
    RandomPositionOffset = {-1, 1 },
    SourceMaterial = MOD_NS .. "TRANSPARENT_PUMPKIN",
    GrowingMaterial = MOD_NS .. "TRANSPARENT_PUMPKIN",
    HarvestedMaterial = MOD_NS .. "DRIED_FIELD_MATERIAL",
    GrowingTextureList = {
    },
    HarvestingTextureList = {
    },
    AlphaTestThreshold = 0.6
})

