local jkPumpkinFarm = ...

-- Growing Setup -------------------------------------------------------------------------------------
jkPumpkinFarm:registerAsset({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = MOD_NS .. "AGENT_WORKSTATION_SETUP_PUMPKIN_FARM_GROWING",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
		IdleAnimation = "MARKET_TENDER"
	}
})

-- Sowing Setup -------------------------------------------------------------------------------------
jkPumpkinFarm:registerAsset({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = MOD_NS .. "AGENT_WORKSTATION_SETUP_PUMPKIN_FARM_SOWING",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
		IdleAnimation = "MARKET_TENDER"
	}
})

-- Harvest Setup -------------------------------------------------------------------------------------
jkPumpkinFarm:registerAsset({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = MOD_NS .. "AGENT_WORKSTATION_SETUP_PUMPKIN_FARM_HARVEST",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
		IdleAnimation = "MARKET_TENDER"
	}
})

jkPumpkinFarm:registerAsset({
    DataType = "BUILDING_FUNCTION_FARM",
    Id = MOD_NS .. "BUILDING_FUNCTION_PUMPKIN_FARM",
    Name = "BUILDING_FUNCTION_PUMPKIN_FARM_NAME",
	WorkerCapacity = 3,
    RelatedJob = { 
        Job = "FARMER", 
        Behavior = "BEHAVIOR_FARMER"
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_PUMPKINS", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_PUMPKINS", Quantity = 1 },
    },

    -- there is a max total cycle of 21 days so if you plan beyond that, it will be cut short
    SowingDurationPerc = {0, PUMPKIN_SOW_END },
	GrowDuration = { PUMPKIN_SOW_END, PUMPKIN_GROW_END }, 
	GrowWaitDuration = { PUMPKIN_GROW_END, PUMPKIN_GROW_END },
	HarvestDuration = { PUMPKIN_GROW_END, PUMPKIN_HARVEST_END },
	RestDuration = { PUMPKIN_HARVEST_END, 21},

    QuantityToHarvestPerStep = 1,
	HarvestStepsCount = 3,
	ResourceValuePerGather = 1,

    QuantityToPlantPerStep = 1,
	PlantingStepsCount = 1,

    CropFieldConfig = MOD_NS .. "FARM_FIELD_CONFIG_PUMPKIN_FARM",
    GrowingSetup = MOD_NS .. "AGENT_WORKSTATION_SETUP_PUMPKIN_FARM_GROWING", 
    SowingSetup = MOD_NS .. "AGENT_WORKSTATION_SETUP_PUMPKIN_FARM_SOWING", 
    HarvestSetup = MOD_NS .. "AGENT_WORKSTATION_SETUP_PUMPKIN_FARM_HARVEST"
})
