local jkPumpkinFarm = ...


PUMPKIN_SOW_END = 5
PUMPKIN_GROW_START = 7
PUMPKIN_GROW_END = 10
PUMPKIN_HARVEST_END = 17
PUMPKIN_REST_START = 18

local PUMPKIN_MANAGER_COMPONENT = {
	TypeName = MOD_NS .. "PUMPKIN_MANAGER_COMPONENT",
	ParentType = "COMPONENT",
    Properties = {
        { Name = "Day", Type = "integer", Default = 1, Flags = { "SAVE_GAME" }},
    }
}


function PUMPKIN_MANAGER_COMPONENT:create()
end

function PUMPKIN_MANAGER_COMPONENT:init()
    local compMainGameLoop = self:getLevel():find("COMP_MAIN_GAME_LOOP")

    event.register(self, compMainGameLoop.ON_NEW_DAY, function()
        self.Day = self.Day + 1
        self.Day = self.Day % 21

        if self.Day > PUMPKIN_GROW_START and self.Day <= PUMPKIN_HARVEST_END then
            self:getLevel():getComponentManager(MOD_NS .. "PUMPKIN_RANDOMIZER_COMPONENT"):getAllComponent():forEach(
                function (cmp)
                    local rand = math.random()
                    if rand < 0.07 then
                        cmp:createPumpkins()
                    end
                end)
        elseif self.Day > PUMPKIN_REST_START then
            self:getLevel():getComponentManager(MOD_NS .. "PUMPKIN_RANDOMIZER_COMPONENT"):getAllComponent():forEach(
                function (cmp)
                    cmp:destroyPumpkins()
                end)
        end
    end)
end

jkPumpkinFarm:registerClass(PUMPKIN_MANAGER_COMPONENT)
jkPumpkinFarm:registerPrefabComponent("PREFAB_MANAGER", { DataType = MOD_NS .. "PUMPKIN_MANAGER_COMPONENT" } )