local jkPumpkinFarm = ...


local PUMPKIN_RANDOMIZER_COMPONENT = {
	TypeName = MOD_NS .. "PUMPKIN_RANDOMIZER_COMPONENT",
	ParentType = "COMPONENT",
    Properties = {
        { Name = "pumpkin", Type = "GAME_OBJECT", Default = nil, Flags = { "SAVE_GAME" }},
    }
}


local prefabs = { MOD_NS .. "PREFAB_PUMPKIN_TYPE_B", MOD_NS .. "PREFAB_PUMPKIN_TYPE_C", MOD_NS .. "PREFAB_PUMPKIN_TYPE_A",
                 MOD_NS .. "PREFAB_PUMPKIN_TYPE_B", MOD_NS .. "PREFAB_PUMPKIN_TYPE_C"}


function PUMPKIN_RANDOMIZER_COMPONENT:destroyPumpkins()
    if self.pumpkin then
        self.pumpkin:destroy()
        self.pumpkin = nil
    end
end

function PUMPKIN_RANDOMIZER_COMPONENT:createPumpkins()
    if self.pumpkin then
        return
    end

	local parent = self:getOwner()
    local prefabIndex = math.random(1, #prefabs)

    self.pumpkin = self:getLevel():createObject(prefabs[prefabIndex], parent:getGlobalPosition(), parent:getGlobalOrientation())
end

function PUMPKIN_RANDOMIZER_COMPONENT:onDestroy(isClearingLevel)
    if isClearingLevel then
        return
    end
    if self.pumpkin then
        self.pumpkin:destroy()
    end
end


jkPumpkinFarm:registerClass(PUMPKIN_RANDOMIZER_COMPONENT)
